Index: libcfs/include/libcfs/bitmap.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/bitmap.h,v
retrieving revision 1.4
diff -u -p -r1.4 bitmap.h
--- libcfs/include/libcfs/bitmap.h	8 Sep 2009 08:09:26 -0000	1.4
+++ libcfs/include/libcfs/bitmap.h	1 Jan 2010 20:03:30 -0000
@@ -36,15 +36,77 @@
 #ifndef _LIBCFS_BITMAP_H_
 #define _LIBCFS_BITMAP_H_
 
+/** \addtogroup libcfs
+ * @{ */
 
+/**
+ * \defgroup libcfs_bitops Bitmask
+ * Generic API for bitmask operations
+ *
+ * The API operates on \a bitmasks - objects aligned to the size of an
+ * "unsigned long" type, and are least of that size. The endianness
+ * of the bits within each "unsigned long" is the native endianness
+ * of the cpu.
+ *
+ * A bitmask may be regarded as numbered set of bits: every bit has a
+ * number equal to its position in bitmask. This allows to perform
+ * main operations using bit number as specification of bit to operate
+ * on. Main operations include:
+ * - set, clear and test bit
+ * - find first zero or non-zero bit starting from the beginning of
+ * bitmask or from specified position
+ *
+ * There are two flavors of API currently provided:
+ *
+ * 1. Low-level API that deals with bitmasks directly. It includes
+ * primitives set_bit, clear_bit, test_bit, find_first_bit, etc. To
+ * use this API, the caller should allocate and maintain bitmask
+ * objects on her own, passing (unsigned long *) pointer to bitmask
+ * and its size to the primitives.
+ *
+ * 2. Hi-level API. It abstracts bitmask object as \a bitmap_t and
+ * provides separate primitives for its allocation and freeing:
+ * ALLOCATE_BITMAP and FREE_BITMAP. After an object of \a bitmap_t
+ * type is allocated, it may be used as argument for subsequent
+ * calls. The names of primitives of this "hi-level" API start from
+ * cfs_ prefix: cfs_bitmap_set, cfs_bitmap_clear, etc.
+ *
+ * Bitmask primitives may be used for many purposes:
+ * - A bitmask may play the role of storage for various flags
+ * reflecting the state of some subsystem (e.g. "RUNNING", "STOPPED",
+ * etc.)
+ * - Tracking business of limited set of resources. If correspondent
+ * bit is set, the resource with given number is "busy" and vice
+ * versa.
+ * - Dynamic numbering of resources. For example, when a client is
+ * connecting to us at first time, find_first_zero_bit may be used to
+ * associate the client with this first unused bit providing the
+ * number for this client. After the number is acquired, the caller
+ * usually sets this bit to mark it as "busy". So, next client will get
+ * next available number.
+ *
+ * NOTE: Currently, Libcfs doesn't guarantee atomicity of operations
+ * like test_and_set_bit on all platforms. Some platforms (like linux
+ * kernel) implement them in atomic way, while others (like
+ * user-space) don't not.
+ * @{
+ */
+
+/**
+ * Generic bitmap - bitmask along with its size
+ */
 typedef struct {
+        /** size of bitmask (in bits) */
         int             size;
+        /** bitmask */
         unsigned long   data[0];
 } bitmap_t;
 
+/** # bytes to afford bitmap_t with bitmask having at least \a bits+1 bits */
 #define CFS_BITMAP_SIZE(nbits) \
      (((nbits/BITS_PER_LONG)+1)*sizeof(long)+sizeof(bitmap_t))
 
+/** allocate bitmap_t with bitmask having at least \a size+1 bits */
 static inline
 bitmap_t *ALLOCATE_BITMAP(int size)
 {
@@ -79,22 +141,28 @@ int cfs_bitmap_check(bitmap_t *bitmap, i
         return test_bit(nbit, bitmap->data);
 }
 
+/** clear bit \a nbit in bitmap \a bitmap
+ * \return previous value of bit \a nbit */
 static inline
 int cfs_bitmap_test_and_clear(bitmap_t *bitmap, int nbit)
 {
         return test_and_clear_bit(nbit, bitmap->data);
 }
 
-/* return 0 is bitmap has none set bits */
+/** return 0 if bitmap has none set bits */
 static inline
 int cfs_bitmap_check_empty(bitmap_t *bitmap)
 {
         return find_first_bit(bitmap->data, bitmap->size) == bitmap->size;
 }
 
+/** Iterates through all non-zero bits in \a bitmap. On each iteration,
+ * \a pos is the number of current non-zero bit (counting from 0) */
 #define cfs_foreach_bit(bitmap, pos) \
 	for((pos)=find_first_bit((bitmap)->data, bitmap->size);   \
             (pos) < (bitmap)->size;                               \
             (pos) = find_next_bit((bitmap)->data, (bitmap)->size, (pos)))
 
+/** @} libcfs_bitops */
+/** @} libcfs */
 #endif
Index: libcfs/include/libcfs/curproc.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/curproc.h,v
retrieving revision 1.4
diff -u -p -r1.4 curproc.h
--- libcfs/include/libcfs/curproc.h	9 Sep 2008 17:52:25 -0000	1.4
+++ libcfs/include/libcfs/curproc.h	1 Jan 2010 20:03:30 -0000
@@ -43,12 +43,30 @@
 #ifndef __LIBCFS_CURPROC_H__
 #define __LIBCFS_CURPROC_H__
 
-#ifdef __KERNEL__
-/*
- * Portable API to access common characteristics of "current" UNIX process.
+/** \addtogroup libcfs
+ * @{ */
+
+/** \defgroup libcfs_curproc Curproc
+ * Generic API to access common characteristics of "current" UNIX process.
  *
- * Implemented in portals/include/libcfs/<os>/
+ * Generic API includes primitives for manipulating capabilities (what an
+ * user is capable to do and what she's not), constant CFS_CURPROC_COMM_MAX and
+ * cfs_curproc_uid. All other curproc primitives are platform-specific add-ons.
+ * @{
+ * \defgroup libcfs_kernel_curproc Curproc (kernel-space)
+ * An extension to generic curproc API for kernel users.
+ * For kernel users, Libcfs provides additional curproc primitives for
+ * accessing to process's gid, fsuid, fsgid, groups membership, umask and
+ * world-visible name of the process.
  */
+
+/* XXX Maxim: The curproc API is currently complete mess containing a lot of
+ * entries that nobody use. To be re-designed to have _single_ clean API for all
+ * cases (kernel/user-space, linux/others). */
+
+#ifdef __KERNEL__
+/** \addtogroup libcfs_kernel_curproc
+ * @{ */
 uid_t  cfs_curproc_uid(void);
 gid_t  cfs_curproc_gid(void);
 uid_t  cfs_curproc_fsuid(void);
@@ -70,8 +88,12 @@ char  *cfs_curproc_comm(void);
  *
  * cfs_kernel_cap_t
  */
+/** @} libcfs_kernel_curproc */
 #endif
 
+/** This type is actually a bitmask where each particular bit may represent some
+ * "capability" - an action (or group of actions) that the user is capable to
+ * perform. */
 typedef __u32 cfs_cap_t;
 
 #define CFS_CAP_CHOWN                   0
@@ -101,6 +123,9 @@ cfs_cap_t cfs_curproc_cap_pack(void);
 void cfs_curproc_cap_unpack(cfs_cap_t cap);
 int cfs_capable(cfs_cap_t cap);
 
+/** @} libcfs_curproc */
+/** @} libcfs */
+
 /* __LIBCFS_CURPROC_H__ */
 #endif
 /*
